/**
 * Displays the about dialog for credits and version information.
 */
public class About : Gtk.AboutDialog
{
  public const string WEBSITE = "https://launchpad.net/recent-notifications";

  public const string[] AUTHORS = {"Jason Conti <jason.conti@gmail.com>", null};

  public const string COMMENTS  = _("View recent notifications");
  public const string COPYRIGHT = _("Copyright © 2010-2011 Jason Conti");
  public const string ICON      = "recent-notifications";
  public const string NAME      = _("Recent Notifications");

  /* Intltool can't seem to handle the verbatim string, so glue it all together in one ugly line */
  public const string LICENSE = _("\nThis program is free software: you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation, either version 3 of the License, or\n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program.  If not, see <http://www.gnu.org/licenses/>.\n");

  public About()
  {
    this.set_authors(AUTHORS);
    this.set_comments(_(COMMENTS));
    this.set_copyright(_(COPYRIGHT));
    this.set_license(_(LICENSE));
    this.set_logo_icon_name(ICON);
    this.set_program_name(_(NAME));
    this.set_translator_credits(_("translator-credits"));
    this.set_version(Config.VERSION);
    this.set_website(WEBSITE);
  }
}
