/*
 * applet.c
 * September 3, 2011
 *
 * A thin wrapper to create a panel applet from vala code.
 *
 */

#include <panel-applet.h>
#include "recent-notifications.h"

static gboolean 
populate_applet_cb(PanelApplet *applet, const gchar *iid, gpointer user_data)
{
  panel_applet_set_flags(applet, PANEL_APPLET_EXPAND_MINOR);

  RecentNotifications *item = recent_notifications_new(applet);
  gtk_container_add(GTK_CONTAINER(applet), GTK_WIDGET(item));

  gtk_widget_show(GTK_WIDGET(applet));
  return TRUE;
}

PANEL_APPLET_OUT_PROCESS_FACTORY("RecentNotificationsFactory",
    PANEL_TYPE_APPLET,
    populate_applet_cb, NULL);
