/**
 * Extends CellRendererText to display an integer property without having to
 * constantly convert between integers and strings.
 */
public class CellRendererInteger : Gtk.CellRendererText
{
  private int _integer;

  /**
   * Update the 'text' property when set.
   */
  public int integer {
    get { return this._integer; }
    set {
      this._integer = value;
      this.text = value.to_string();
    }
  }
}
