namespace Panel {
	[CCode (cheader_filename = "panel-applet.h")]
	public class Applet : Gtk.EventBox, Atk.Implementor, Gtk.Buildable {
		[CCode (has_construct_function = false)]
		protected Applet ();
		public void add_preferences (string schema_dir) throws GLib.Error;
		public static int factory_main (string factory_id, GLib.Type applet_type, Panel.AppletFactoryCallback callback, void* data);
		public static int factory_setup_in_process (string factory_id, GLib.Type applet_type, Panel.AppletFactoryCallback callback, void* data);
		public unowned Cairo.Pattern get_background ();
		public Panel.AppletFlags get_flags ();
		public bool get_locked_down ();
		public Panel.AppletOrient get_orient ();
		public unowned string get_preferences_key ();
		public uint get_size ();
		public void request_focus (uint32 timestamp);
		public void set_background_widget (Gtk.Widget widget);
		public void set_flags (Panel.AppletFlags flags);
		public void set_size_hints (int size_hints, int n_elements, int base_size);
		public unowned GLib.Settings settings_new (string schema);
		public void setup_menu (string xml, Gtk.ActionGroup action_group);
		public void setup_menu_from_file (string filename, Gtk.ActionGroup action_group);
		[NoAccessorMethod]
		public string background { owned get; set; }
		[NoAccessorMethod]
		public void* closure { get; construct; }
		[NoAccessorMethod]
		public GLib.DBusConnection connection { owned get; construct; }
		public uint flags { get; set; }
		[NoAccessorMethod]
		public string id { owned get; construct; }
		[NoAccessorMethod]
		public bool locked_down { get; set; }
		[NoAccessorMethod]
		public uint orient { get; set; }
		[NoAccessorMethod]
		public string prefs_key { owned get; set; }
		[NoAccessorMethod]
		public string settings_path { owned get; set; }
		[NoAccessorMethod]
		public uint size { get; set; }
		[NoAccessorMethod]
		public void* size_hints { get; set; }
		public virtual signal void change_background (Cairo.Pattern pattern);
		public virtual signal void change_orient (Panel.AppletOrient orient);
		public virtual signal void change_size (int size);
		public virtual signal void move_focus_out_of_applet (Gtk.DirectionType direction);
	}
	[CCode (cheader_filename = "panel-applet.h", cprefix = "PANEL_APPLET_")]
	[Flags]
	public enum AppletFlags {
		FLAGS_NONE,
		EXPAND_MAJOR,
		EXPAND_MINOR,
		HAS_HANDLE
	}
	[CCode (cheader_filename = "panel-applet.h", cprefix = "PANEL_APPLET_ORIENT_")]
	public enum AppletOrient {
		UP,
		DOWN,
		LEFT,
		RIGHT
	}
	[CCode (cheader_filename = "panel-applet.h")]
	public delegate bool AppletFactoryCallback (Panel.Applet applet, string iid);
	[CCode (cheader_filename = "panel-applet.h")]
	public const int APPLET_FLAGS_ALL;
}
