/* logging.c generated by valac 0.16.0, the Vala compiler
 * generated from logging.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define TYPE_LOGGING (logging_get_type ())
#define LOGGING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGGING, Logging))
#define LOGGING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGGING, LoggingClass))
#define IS_LOGGING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGGING))
#define IS_LOGGING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGGING))
#define LOGGING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGGING, LoggingClass))

typedef struct _Logging Logging;
typedef struct _LoggingClass LoggingClass;
typedef struct _LoggingPrivate LoggingPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

struct _Logging {
	GObject parent_instance;
	LoggingPrivate * priv;
};

struct _LoggingClass {
	GObjectClass parent_class;
};

struct _LoggingPrivate {
	gchar* _log_path;
	FILE* _log_file;
	gboolean _log_debug;
	gboolean _log_to_console;
};


static gpointer logging_parent_class = NULL;

GType logging_get_type (void) G_GNUC_CONST;
#define LOGGING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LOGGING, LoggingPrivate))
enum  {
	LOGGING_DUMMY_PROPERTY,
	LOGGING_LOG_DEBUG,
	LOGGING_LOG_TO_CONSOLE
};
Logging* logging_new (const gchar* log_filename);
Logging* logging_construct (GType object_type, const gchar* log_filename);
static void logging_logging_cb (Logging* self, const gchar* domain, GLogLevelFlags level, const gchar* message);
static void _logging_logging_cb_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self);
gboolean logging_get_log_debug (Logging* self);
void logging_set_log_debug (Logging* self, gboolean value);
gboolean logging_get_log_to_console (Logging* self);
void logging_set_log_to_console (Logging* self, gboolean value);
static void logging_finalize (GObject* obj);
static void _vala_logging_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_logging_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
   * Configures logging to a file in the user cache directory (generally
   * ~/.cache/).
   *
   * @param log_filename the filename for the log file
   */
static void _logging_logging_cb_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self) {
	logging_logging_cb (self, log_domain, log_levels, message);
}


Logging* logging_construct (GType object_type, const gchar* log_filename) {
	Logging * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* cache_dir;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	FILE* _tmp7_ = NULL;
	FILE* _tmp8_;
	g_return_val_if_fail (log_filename != NULL, NULL);
	self = (Logging*) g_object_new (object_type, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	cache_dir = _tmp1_;
	_tmp2_ = cache_dir;
	_tmp3_ = log_filename;
	_tmp4_ = g_build_filename (_tmp2_, _tmp3_, NULL, NULL);
	_g_free0 (self->priv->_log_path);
	self->priv->_log_path = _tmp4_;
	_tmp5_ = cache_dir;
	g_mkdir_with_parents (_tmp5_, 0700);
	_tmp6_ = self->priv->_log_path;
	_tmp7_ = fopen (_tmp6_, "w");
	_fclose0 (self->priv->_log_file);
	self->priv->_log_file = _tmp7_;
	g_log_set_default_handler (_logging_logging_cb_glog_func, self);
	_tmp8_ = self->priv->_log_file;
	if (_tmp8_ == NULL) {
		const gchar* _tmp9_;
		_tmp9_ = self->priv->_log_path;
		g_warning ("logging.vala:30: Failed to open log file: %s", _tmp9_);
	} else {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->_log_path;
		g_debug ("logging.vala:32: Logging to %s", _tmp10_);
	}
	_g_free0 (cache_dir);
	return self;
}


Logging* logging_new (const gchar* log_filename) {
	return logging_construct (TYPE_LOGGING, log_filename);
}


/**
   * Logs messages to both a file and to the console.
   *
   * @param domain the domain of the message [currently ignored]
   * @param level the log level (debug, warning, error, ...)
   * @param message the log message
   */
static void logging_logging_cb (Logging* self, const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gchar* _tmp0_;
	gchar* prefix;
	FILE* _tmp1_;
	FILE* console;
	GLogLevelFlags _tmp2_;
	FILE* _tmp14_;
	gboolean _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup ("LOG:");
	prefix = _tmp0_;
	_tmp1_ = stdout;
	console = _tmp1_;
	_tmp2_ = level;
	switch (_tmp2_) {
		case G_LOG_LEVEL_ERROR:
		{
			gchar* _tmp3_;
			FILE* _tmp4_;
			_tmp3_ = g_strdup ("ERROR:");
			_g_free0 (prefix);
			prefix = _tmp3_;
			_tmp4_ = stderr;
			console = _tmp4_;
			break;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			gchar* _tmp5_;
			FILE* _tmp6_;
			_tmp5_ = g_strdup ("CRITICAL:");
			_g_free0 (prefix);
			prefix = _tmp5_;
			_tmp6_ = stderr;
			console = _tmp6_;
			break;
		}
		case G_LOG_LEVEL_WARNING:
		{
			gchar* _tmp7_;
			FILE* _tmp8_;
			_tmp7_ = g_strdup ("WARNING:");
			_g_free0 (prefix);
			prefix = _tmp7_;
			_tmp8_ = stderr;
			console = _tmp8_;
			break;
		}
		case G_LOG_LEVEL_MESSAGE:
		{
			gchar* _tmp9_;
			FILE* _tmp10_;
			_tmp9_ = g_strdup ("MESSAGE:");
			_g_free0 (prefix);
			prefix = _tmp9_;
			_tmp10_ = stderr;
			console = _tmp10_;
			break;
		}
		case G_LOG_LEVEL_INFO:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("INFO:");
			_g_free0 (prefix);
			prefix = _tmp11_;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			gboolean _tmp12_;
			gchar* _tmp13_;
			_tmp12_ = self->priv->_log_debug;
			if (!_tmp12_) {
				_g_free0 (prefix);
				return;
			}
			_tmp13_ = g_strdup ("DEBUG:");
			_g_free0 (prefix);
			prefix = _tmp13_;
			break;
		}
		default:
		break;
	}
	_tmp14_ = self->priv->_log_file;
	if (_tmp14_ != NULL) {
		FILE* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		FILE* _tmp18_;
		_tmp15_ = self->priv->_log_file;
		_tmp16_ = prefix;
		_tmp17_ = message;
		fprintf (_tmp15_, "%s %s\n", _tmp16_, _tmp17_);
		_tmp18_ = self->priv->_log_file;
		fflush (_tmp18_);
	}
	_tmp19_ = self->priv->_log_to_console;
	if (_tmp19_) {
		FILE* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp20_ = console;
		_tmp21_ = prefix;
		_tmp22_ = message;
		fprintf (_tmp20_, "%s %s\n", _tmp21_, _tmp22_);
	}
	_g_free0 (prefix);
}


gboolean logging_get_log_debug (Logging* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_log_debug;
	result = _tmp0_;
	return result;
}


void logging_set_log_debug (Logging* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_log_debug = _tmp0_;
	g_object_notify ((GObject *) self, "log-debug");
}


gboolean logging_get_log_to_console (Logging* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_log_to_console;
	result = _tmp0_;
	return result;
}


void logging_set_log_to_console (Logging* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_log_to_console = _tmp0_;
	g_object_notify ((GObject *) self, "log-to-console");
}


static void logging_class_init (LoggingClass * klass) {
	logging_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LoggingPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_logging_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_logging_set_property;
	G_OBJECT_CLASS (klass)->finalize = logging_finalize;
	/**
	   * Property to determine if debug messages are logged.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGGING_LOG_DEBUG, g_param_spec_boolean ("log-debug", "log-debug", "log-debug", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * Property to determine if messages are logged to the console.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGGING_LOG_TO_CONSOLE, g_param_spec_boolean ("log-to-console", "log-to-console", "log-to-console", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void logging_instance_init (Logging * self) {
	self->priv = LOGGING_GET_PRIVATE (self);
	self->priv->_log_debug = TRUE;
	self->priv->_log_to_console = TRUE;
}


static void logging_finalize (GObject* obj) {
	Logging * self;
	self = LOGGING (obj);
	_g_free0 (self->priv->_log_path);
	_fclose0 (self->priv->_log_file);
	G_OBJECT_CLASS (logging_parent_class)->finalize (obj);
}


/**
 * Enables logging to both a file and the console using standard GLib functions
 * (debug/warning/error etc).
 */
GType logging_get_type (void) {
	static volatile gsize logging_type_id__volatile = 0;
	if (g_once_init_enter (&logging_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LoggingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) logging_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Logging), 0, (GInstanceInitFunc) logging_instance_init, NULL };
		GType logging_type_id;
		logging_type_id = g_type_register_static (G_TYPE_OBJECT, "Logging", &g_define_type_info, 0);
		g_once_init_leave (&logging_type_id__volatile, logging_type_id);
	}
	return logging_type_id__volatile;
}


static void _vala_logging_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Logging * self;
	self = LOGGING (object);
	switch (property_id) {
		case LOGGING_LOG_DEBUG:
		g_value_set_boolean (value, logging_get_log_debug (self));
		break;
		case LOGGING_LOG_TO_CONSOLE:
		g_value_set_boolean (value, logging_get_log_to_console (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_logging_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Logging * self;
	self = LOGGING (object);
	switch (property_id) {
		case LOGGING_LOG_DEBUG:
		logging_set_log_debug (self, g_value_get_boolean (value));
		break;
		case LOGGING_LOG_TO_CONSOLE:
		logging_set_log_to_console (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



