public static void test_notification()
{
  Test.add_func("/notification/is_empty", () => {
    Notification message_1 = new Notification.from_data("Test App", 
        "test-icon", "", "");
    Notification message_2 = new Notification.from_data("Test App", 
        "test-icon", "This has a summary but no body", "");

    assert(message_1.is_empty());
    assert(!message_2.is_empty());
  });

  Test.add_func("/notification/links", () => {
    Notification message_1 = new Notification.from_data("Internet Client", 
        "internet-client", "This message has a link", 
        "Visit http://www.google.com for more details.");
    Notification message_2 = new Notification.from_data("Streaming Service", 
        "streaming-service", "Multiple Links",
        "Received transmission from www.example.com/streams via http://www.yahoo.com");
    Notification message_3 = new Notification.from_data("Command Link Client",
        "command-line-client", "No links here",
        "This message has 0 links.");

    string[] links = message_1.get_embedded_links();
    assert(links.length == 1);
    assert(links[0] == "http://www.google.com");

    links = message_2.get_embedded_links();
    assert(links.length == 2);
    assert(links[0] == "http://www.example.com/streams");
    assert(links[1] == "http://www.yahoo.com");

    links = message_3.get_embedded_links();
    assert(links.length == 0);
  });
}
